/* PlugsManager.c generated by valac 0.38.10, the Vala compiler
 * generated from PlugsManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2014 Switchboard Developers (http://launchpad.net/switchboard)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementaryos.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gio/gio.h>
#include "config.h"
#include <stdlib.h>
#include <string.h>
#include <gmodule.h>


#define SWITCHBOARD_TYPE_PLUGS_MANAGER (switchboard_plugs_manager_get_type ())
#define SWITCHBOARD_PLUGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SWITCHBOARD_TYPE_PLUGS_MANAGER, SwitchboardPlugsManager))
#define SWITCHBOARD_PLUGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SWITCHBOARD_TYPE_PLUGS_MANAGER, SwitchboardPlugsManagerClass))
#define SWITCHBOARD_IS_PLUGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SWITCHBOARD_TYPE_PLUGS_MANAGER))
#define SWITCHBOARD_IS_PLUGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SWITCHBOARD_TYPE_PLUGS_MANAGER))
#define SWITCHBOARD_PLUGS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SWITCHBOARD_TYPE_PLUGS_MANAGER, SwitchboardPlugsManagerClass))

typedef struct _SwitchboardPlugsManager SwitchboardPlugsManager;
typedef struct _SwitchboardPlugsManagerClass SwitchboardPlugsManagerClass;
typedef struct _SwitchboardPlugsManagerPrivate SwitchboardPlugsManagerPrivate;

#define SWITCHBOARD_TYPE_PLUG (switchboard_plug_get_type ())
#define SWITCHBOARD_PLUG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SWITCHBOARD_TYPE_PLUG, SwitchboardPlug))
#define SWITCHBOARD_PLUG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SWITCHBOARD_TYPE_PLUG, SwitchboardPlugClass))
#define SWITCHBOARD_IS_PLUG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SWITCHBOARD_TYPE_PLUG))
#define SWITCHBOARD_IS_PLUG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SWITCHBOARD_TYPE_PLUG))
#define SWITCHBOARD_PLUG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SWITCHBOARD_TYPE_PLUG, SwitchboardPlugClass))

typedef struct _SwitchboardPlug SwitchboardPlug;
typedef struct _SwitchboardPlugClass SwitchboardPlugClass;
enum  {
	SWITCHBOARD_PLUGS_MANAGER_0_PROPERTY,
	SWITCHBOARD_PLUGS_MANAGER_NUM_PROPERTIES
};
static GParamSpec* switchboard_plugs_manager_properties[SWITCHBOARD_PLUGS_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_module_close0(var) ((var == NULL) ? NULL : (var = (g_module_close (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	SWITCHBOARD_PLUGS_MANAGER_PLUG_ADDED_SIGNAL,
	SWITCHBOARD_PLUGS_MANAGER_NUM_SIGNALS
};
static guint switchboard_plugs_manager_signals[SWITCHBOARD_PLUGS_MANAGER_NUM_SIGNALS] = {0};

struct _SwitchboardPlugsManager {
	GObject parent_instance;
	SwitchboardPlugsManagerPrivate * priv;
};

struct _SwitchboardPlugsManagerClass {
	GObjectClass parent_class;
};

struct _SwitchboardPlugsManagerPrivate {
	GeeLinkedList* plugs;
};

typedef SwitchboardPlug* (*SwitchboardPlugsManagerRegisterPluginFunction) (GModule* module);

static gpointer switchboard_plugs_manager_parent_class = NULL;
static SwitchboardPlugsManager* switchboard_plugs_manager_plugs_manager;
static SwitchboardPlugsManager* switchboard_plugs_manager_plugs_manager = NULL;

GType switchboard_plugs_manager_get_type (void) G_GNUC_CONST;
GType switchboard_plug_get_type (void) G_GNUC_CONST;
#define SWITCHBOARD_PLUGS_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SWITCHBOARD_TYPE_PLUGS_MANAGER, SwitchboardPlugsManagerPrivate))
SwitchboardPlugsManager* switchboard_plugs_manager_get_default (void);
static SwitchboardPlugsManager* switchboard_plugs_manager_new (void);
static SwitchboardPlugsManager* switchboard_plugs_manager_construct (GType object_type);
static void switchboard_plugs_manager_find_plugins (SwitchboardPlugsManager* self, GFile* base_folder);
static void switchboard_plugs_manager_load (SwitchboardPlugsManager* self, const gchar* path);
static void switchboard_plugs_manager_register_plug (SwitchboardPlugsManager* self, SwitchboardPlug* plug);
const gchar* switchboard_plug_get_code_name (SwitchboardPlug* self);
gboolean switchboard_plugs_manager_has_plugs (SwitchboardPlugsManager* self);
GeeCollection* switchboard_plugs_manager_get_plugs (SwitchboardPlugsManager* self);
static void switchboard_plugs_manager_finalize (GObject * obj);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


SwitchboardPlugsManager* switchboard_plugs_manager_get_default (void) {
	SwitchboardPlugsManager* result = NULL;
	SwitchboardPlugsManager* _tmp0_;
	SwitchboardPlugsManager* _tmp2_;
	SwitchboardPlugsManager* _tmp3_;
	_tmp0_ = switchboard_plugs_manager_plugs_manager;
	if (_tmp0_ == NULL) {
		SwitchboardPlugsManager* _tmp1_;
		_tmp1_ = switchboard_plugs_manager_new ();
		_g_object_unref0 (switchboard_plugs_manager_plugs_manager);
		switchboard_plugs_manager_plugs_manager = _tmp1_;
	}
	_tmp2_ = switchboard_plugs_manager_plugs_manager;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	result = _tmp3_;
	return result;
}


static SwitchboardPlugsManager* switchboard_plugs_manager_construct (GType object_type) {
	SwitchboardPlugsManager * self = NULL;
	GeeLinkedList* _tmp0_;
	GFile* base_folder = NULL;
	GFile* _tmp1_;
	self = (SwitchboardPlugsManager*) g_object_new (object_type, NULL);
	_tmp0_ = gee_linked_list_new (SWITCHBOARD_TYPE_PLUG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->plugs);
	self->priv->plugs = _tmp0_;
	_tmp1_ = g_file_new_for_path (PLUGS_DIR);
	base_folder = _tmp1_;
	switchboard_plugs_manager_find_plugins (self, base_folder);
	_g_object_unref0 (base_folder);
	return self;
}


static SwitchboardPlugsManager* switchboard_plugs_manager_new (void) {
	return switchboard_plugs_manager_construct (SWITCHBOARD_TYPE_PLUGS_MANAGER);
}


static void switchboard_plugs_manager_load (SwitchboardPlugsManager* self, const gchar* path) {
	gboolean _tmp0_;
	GModule* module = NULL;
	const gchar* _tmp1_;
	GModule* _tmp2_;
	GModule* _tmp3_;
	void* function = NULL;
	GModule* _tmp5_;
	void* _tmp6_ = NULL;
	void* _tmp7_;
	SwitchboardPlugsManagerRegisterPluginFunction register_plugin = NULL;
	void* _tmp9_;
	SwitchboardPlug* plug = NULL;
	SwitchboardPlugsManagerRegisterPluginFunction _tmp10_;
	GModule* _tmp11_;
	SwitchboardPlug* _tmp12_;
	SwitchboardPlug* _tmp13_;
	GModule* _tmp15_;
	SwitchboardPlug* _tmp16_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = g_module_supported ();
	if (_tmp0_ == FALSE) {
		g_error ("PlugsManager.vala:46: Switchboard is not supported by this system!");
	}
	_tmp1_ = path;
	_tmp2_ = g_module_open (_tmp1_, G_MODULE_BIND_LAZY);
	module = _tmp2_;
	_tmp3_ = module;
	if (_tmp3_ == NULL) {
		const gchar* _tmp4_;
		_tmp4_ = g_module_error ();
		g_critical ("PlugsManager.vala:51: %s", _tmp4_);
		_g_module_close0 (module);
		return;
	}
	_tmp5_ = module;
	g_module_symbol (_tmp5_, "get_plug", &_tmp6_);
	function = _tmp6_;
	_tmp7_ = function;
	if (_tmp7_ == NULL) {
		const gchar* _tmp8_;
		_tmp8_ = path;
		g_critical ("PlugsManager.vala:58: get_plug () not found in %s", _tmp8_);
		_g_module_close0 (module);
		return;
	}
	_tmp9_ = function;
	register_plugin = (SwitchboardPlugsManagerRegisterPluginFunction) _tmp9_;
	_tmp10_ = register_plugin;
	_tmp11_ = module;
	_tmp12_ = _tmp10_ (_tmp11_);
	plug = _tmp12_;
	_tmp13_ = plug;
	if (_tmp13_ == NULL) {
		const gchar* _tmp14_;
		_tmp14_ = path;
		g_critical ("PlugsManager.vala:65: Unknown plugin type for %s !", _tmp14_);
		_g_object_unref0 (plug);
		_g_module_close0 (module);
		return;
	}
	_tmp15_ = module;
	g_module_make_resident (_tmp15_);
	_tmp16_ = plug;
	switchboard_plugs_manager_register_plug (self, _tmp16_);
	_g_object_unref0 (plug);
	_g_module_close0 (module);
}


static void switchboard_plugs_manager_find_plugins (SwitchboardPlugsManager* self, GFile* base_folder) {
	GFileInfo* file_info = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (base_folder != NULL);
	file_info = NULL;
	{
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp0_;
		GFileEnumerator* _tmp1_;
		_tmp0_ = base_folder;
		_tmp1_ = g_file_enumerate_children (_tmp0_, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, 0, NULL, &_inner_error_);
		enumerator = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch0_g_error;
		}
		while (TRUE) {
			GFileInfo* _tmp2_ = NULL;
			GFileEnumerator* _tmp3_;
			GFileInfo* _tmp4_;
			GFileInfo* _tmp5_;
			GFileInfo* _tmp6_;
			GFile* file = NULL;
			GFile* _tmp7_;
			GFileInfo* _tmp8_;
			const gchar* _tmp9_;
			GFile* _tmp10_;
			gboolean _tmp11_ = FALSE;
			GFileInfo* _tmp12_;
			GFileType _tmp13_;
			_tmp3_ = enumerator;
			_tmp4_ = g_file_enumerator_next_file (_tmp3_, NULL, &_inner_error_);
			_tmp2_ = _tmp4_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (enumerator);
				goto __catch0_g_error;
			}
			_tmp5_ = _tmp2_;
			_tmp2_ = NULL;
			_g_object_unref0 (file_info);
			file_info = _tmp5_;
			_tmp6_ = file_info;
			if (!(_tmp6_ != NULL)) {
				_g_object_unref0 (_tmp2_);
				break;
			}
			_tmp7_ = base_folder;
			_tmp8_ = file_info;
			_tmp9_ = g_file_info_get_name (_tmp8_);
			_tmp10_ = g_file_get_child (_tmp7_, _tmp9_);
			file = _tmp10_;
			_tmp12_ = file_info;
			_tmp13_ = g_file_info_get_file_type (_tmp12_);
			if (_tmp13_ == G_FILE_TYPE_REGULAR) {
				GFileInfo* _tmp14_;
				const gchar* _tmp15_;
				gboolean _tmp16_;
				_tmp14_ = file_info;
				_tmp15_ = g_file_info_get_content_type (_tmp14_);
				_tmp16_ = g_content_type_equals (_tmp15_, "application/x-sharedlib");
				_tmp11_ = _tmp16_;
			} else {
				_tmp11_ = FALSE;
			}
			if (_tmp11_) {
				gchar* path = NULL;
				GFile* _tmp17_;
				gchar* _tmp18_;
				const gchar* _tmp19_;
				gboolean _tmp20_;
				_tmp17_ = file;
				_tmp18_ = g_file_get_path (_tmp17_);
				path = _tmp18_;
				_tmp19_ = path;
				_tmp20_ = g_str_has_suffix (_tmp19_, G_MODULE_SUFFIX);
				if (_tmp20_) {
					const gchar* _tmp21_;
					_tmp21_ = path;
					switchboard_plugs_manager_load (self, _tmp21_);
				}
				_g_free0 (path);
			} else {
				GFileInfo* _tmp22_;
				GFileType _tmp23_;
				_tmp22_ = file_info;
				_tmp23_ = g_file_info_get_file_type (_tmp22_);
				if (_tmp23_ == G_FILE_TYPE_DIRECTORY) {
					GFile* _tmp24_;
					_tmp24_ = file;
					switchboard_plugs_manager_find_plugins (self, _tmp24_);
				}
			}
			_g_object_unref0 (file);
			_g_object_unref0 (_tmp2_);
		}
		_g_object_unref0 (enumerator);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GFile* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		GError* _tmp28_;
		const gchar* _tmp29_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp25_ = base_folder;
		_tmp26_ = g_file_get_path (_tmp25_);
		_tmp27_ = _tmp26_;
		_tmp28_ = err;
		_tmp29_ = _tmp28_->message;
		g_warning ("PlugsManager.vala:89: Unable to scan plugs folder %s: %s\n", _tmp27_, _tmp29_);
		_g_free0 (_tmp27_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (file_info);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_object_unref0 (file_info);
}


static void switchboard_plugs_manager_register_plug (SwitchboardPlugsManager* self, SwitchboardPlug* plug) {
	SwitchboardPlug* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GeeLinkedList* _tmp3_;
	SwitchboardPlug* _tmp4_;
	gboolean _tmp5_;
	GeeLinkedList* _tmp6_;
	SwitchboardPlug* _tmp7_;
	SwitchboardPlug* _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (plug != NULL);
	_tmp0_ = plug;
	_tmp1_ = switchboard_plug_get_code_name (_tmp0_);
	_tmp2_ = _tmp1_;
	g_debug ("PlugsManager.vala:94: %s registered", _tmp2_);
	_tmp3_ = self->priv->plugs;
	_tmp4_ = plug;
	_tmp5_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp3_, _tmp4_);
	if (_tmp5_) {
		return;
	}
	_tmp6_ = self->priv->plugs;
	_tmp7_ = plug;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, _tmp7_);
	_tmp8_ = plug;
	g_signal_emit (self, switchboard_plugs_manager_signals[SWITCHBOARD_PLUGS_MANAGER_PLUG_ADDED_SIGNAL], 0, _tmp8_);
}


gboolean switchboard_plugs_manager_has_plugs (SwitchboardPlugsManager* self) {
	gboolean result = FALSE;
	GeeLinkedList* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->plugs;
	_tmp1_ = gee_collection_get_is_empty ((GeeCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = !_tmp2_;
	return result;
}


GeeCollection* switchboard_plugs_manager_get_plugs (SwitchboardPlugsManager* self) {
	GeeCollection* result = NULL;
	GeeLinkedList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->plugs;
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = (GeeCollection*) _tmp2_;
	return result;
}


static void switchboard_plugs_manager_class_init (SwitchboardPlugsManagerClass * klass) {
	switchboard_plugs_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SwitchboardPlugsManagerPrivate));
	G_OBJECT_CLASS (klass)->finalize = switchboard_plugs_manager_finalize;
	switchboard_plugs_manager_signals[SWITCHBOARD_PLUGS_MANAGER_PLUG_ADDED_SIGNAL] = g_signal_new ("plug-added", SWITCHBOARD_TYPE_PLUGS_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, SWITCHBOARD_TYPE_PLUG);
}


static void switchboard_plugs_manager_instance_init (SwitchboardPlugsManager * self) {
	self->priv = SWITCHBOARD_PLUGS_MANAGER_GET_PRIVATE (self);
}


static void switchboard_plugs_manager_finalize (GObject * obj) {
	SwitchboardPlugsManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SWITCHBOARD_TYPE_PLUGS_MANAGER, SwitchboardPlugsManager);
	_g_object_unref0 (self->priv->plugs);
	G_OBJECT_CLASS (switchboard_plugs_manager_parent_class)->finalize (obj);
}


GType switchboard_plugs_manager_get_type (void) {
	static volatile gsize switchboard_plugs_manager_type_id__volatile = 0;
	if (g_once_init_enter (&switchboard_plugs_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SwitchboardPlugsManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) switchboard_plugs_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SwitchboardPlugsManager), 0, (GInstanceInitFunc) switchboard_plugs_manager_instance_init, NULL };
		GType switchboard_plugs_manager_type_id;
		switchboard_plugs_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "SwitchboardPlugsManager", &g_define_type_info, 0);
		g_once_init_leave (&switchboard_plugs_manager_type_id__volatile, switchboard_plugs_manager_type_id);
	}
	return switchboard_plugs_manager_type_id__volatile;
}



